Index: trunk/client/modules/Elezioni/grafici/gd_image.inc.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/gd_image.inc.php	(revision 265)
+++ trunk/client/modules/Elezioni/grafici/gd_image.inc.php	(revision 267)
@@ -1,58 +1,32 @@
 <?php
 //=======================================================================
-// File:        GD_IMAGE.INC.PHP
-// Description: PHP Graph Plotting library. Low level image drawing routines
-// Created:     2001-01-08, refactored 2008-03-29
-// Ver:         $Id: gd_image.inc.php 1922 2010-01-11 11:42:50Z ljp $
+// File:	GD_IMAGE.INC.PHP
+// Description:	PHP Graph Plotting library. Low level image drawing routines
+// Created: 	2001-01-08, refactored 2008-03-29
+// Ver:		$Id$
 //
-// Copyright (c) Asial Corporation. All rights reserved.
+// Copyright (c) Aditus Consulting. All rights reserved.
 //========================================================================
 
-require_once 'jpgraph_rgb.inc.php';
-require_once 'jpgraph_ttf.inc.php';
-require_once 'imageSmoothArc.php';
-require_once 'jpgraph_errhandler.inc.php';
-
-// Line styles
-define('LINESTYLE_SOLID',1);
-define('LINESTYLE_DOTTED',2);
-define('LINESTYLE_DASHED',3);
-define('LINESTYLE_LONGDASH',4);
-
-// The DEFAULT_GFORMAT sets the default graphic encoding format, i.e.
-// PNG, JPG or GIF depending on what is installed on the target system
-// in that order.
-if( !DEFINED("DEFAULT_GFORMAT") ) {
-    define("DEFAULT_GFORMAT","auto");
-}
-
-//========================================================================
+	
+//===================================================
 // CLASS Image
-// Description: The very coor image drawing class that encapsulates all
-//              calls to the GD library
-//              Note: The class used by the library is the decendant
-//              class RotImage which extends the Image class with transparent
-//              rotation.
-//=========================================================================
+// Description: Wrapper class with some goodies to form the
+// Interface to low level image drawing routines.
+//===================================================
 class Image {
+    public $left_margin=30,$right_margin=30,$top_margin=20,$bottom_margin=30;
     public $img=null;
+    public $plotwidth=0,$plotheight=0;
+    public $width=0, $height=0;
     public $rgb=null;
+    public $current_color,$current_color_name;
+    public $line_weight=1, $line_style=LINESTYLE_SOLID;	
     public $img_format;
     public $ttf=null;
-    public $line_style=LINESTYLE_SOLID;
-    public $current_color,$current_color_name;
-    public $original_width=0, $original_height=0;
-    public $plotwidth=0,$plotheight=0;
-
-    // for __get, __set
-    private $_left_margin=30,$_right_margin=30,$_top_margin=20,$_bottom_margin=30;
-    //private $_plotwidth=0,$_plotheight=0;
-    private $_width=0, $_height=0;
-    private $_line_weight=1;
-
     protected $expired=true;
     protected $lastx=0, $lasty=0;
     protected $obs_list=array();
-    protected $font_size=12,$font_family=FF_DEFAULT, $font_style=FS_NORMAL;
+    protected $font_size=12,$font_family=FF_FONT1, $font_style=FS_NORMAL;
     protected $font_file='';
     protected $text_halign="left",$text_valign="bottom";
Index: trunk/client/modules/Elezioni/grafici/gd_image.inc.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/gd_image.inc.php	(revision 265)
+++ trunk/client/modules/Elezioni/grafici/gd_image.inc.php	(revision 267)
@@ -1948,172 +1303,173 @@
 class RotImage extends Image {
     public $a=0;
-    public $dx=0,$dy=0,$transx=0,$transy=0;
+    public $dx=0,$dy=0,$transx=0,$transy=0; 
     private $m=array();
-
-    function __construct($aWidth,$aHeight,$a=0,$aFormat=DEFAULT_GFORMAT,$aSetAutoMargin=true) {
-        parent::__construct($aWidth,$aHeight,$aFormat,$aSetAutoMargin);
-        $this->dx=$this->width/2;
-        $this->dy=$this->height/2;
-        $this->SetAngle($a);
-    }
-
+	
+    function RotImage($aWidth,$aHeight,$a=0,$aFormat=DEFAULT_GFORMAT,$aSetAutoMargin=true) {
+	$this->Image($aWidth,$aHeight,$aFormat,$aSetAutoMargin);
+	$this->dx=$this->left_margin+$this->plotwidth/2;
+	$this->dy=$this->top_margin+$this->plotheight/2;
+	$this->SetAngle($a);	
+    }
+	
     function SetCenter($dx,$dy) {
-        $old_dx = $this->dx;
-        $old_dy = $this->dy;
-        $this->dx=$dx;
-        $this->dy=$dy;
-        $this->SetAngle($this->a);
-        return array($old_dx,$old_dy);
-    }
-
+	$old_dx = $this->dx;
+	$old_dy = $this->dy;
+	$this->dx=$dx;
+	$this->dy=$dy;
+	$this->SetAngle($this->a);
+	return array($old_dx,$old_dy);
+    }
+	
     function SetTranslation($dx,$dy) {
-        $old = array($this->transx,$this->transy);
-        $this->transx = $dx;
-        $this->transy = $dy;
-        return $old;
+	$old = array($this->transx,$this->transy);
+	$this->transx = $dx;
+	$this->transy = $dy;
+	return $old;
     }
 
     function UpdateRotMatrice()  {
-        $a = $this->a;
-        $a *= M_PI/180;
-        $sa=sin($a); $ca=cos($a);
-        // Create the rotation matrix
-        $this->m[0][0] = $ca;
-        $this->m[0][1] = -$sa;
-        $this->m[0][2] = $this->dx*(1-$ca) + $sa*$this->dy ;
-        $this->m[1][0] = $sa;
-        $this->m[1][1] = $ca;
-        $this->m[1][2] = $this->dy*(1-$ca) - $sa*$this->dx ;
+	$a = $this->a;
+	$a *= M_PI/180;
+	$sa=sin($a); $ca=cos($a);		
+	// Create the rotation matrix
+	$this->m[0][0] = $ca;
+	$this->m[0][1] = -$sa;
+	$this->m[0][2] = $this->dx*(1-$ca) + $sa*$this->dy ;
+	$this->m[1][0] = $sa;
+	$this->m[1][1] = $ca;
+	$this->m[1][2] = $this->dy*(1-$ca) - $sa*$this->dx ;
     }
 
     function SetAngle($a) {
-        $tmp = $this->a;
-        $this->a = $a;
-        $this->UpdateRotMatrice();
-        return $tmp;
+	$tmp = $this->a;
+	$this->a = $a;
+	$this->UpdateRotMatrice();
+	return $tmp;
     }
 
     function Circle($xc,$yc,$r) {
-        list($xc,$yc) = $this->Rotate($xc,$yc);
-        parent::Circle($xc,$yc,$r);
+	list($xc,$yc) = $this->Rotate($xc,$yc);
+	parent::Circle($xc,$yc,$r);
     }
 
     function FilledCircle($xc,$yc,$r) {
-        list($xc,$yc) = $this->Rotate($xc,$yc);
-        parent::FilledCircle($xc,$yc,$r);
-    }
-
-
+	list($xc,$yc) = $this->Rotate($xc,$yc);
+	parent::FilledCircle($xc,$yc,$r);
+    }
+
+	
     function Arc($xc,$yc,$w,$h,$s,$e) {
-        list($xc,$yc) = $this->Rotate($xc,$yc);
-        $s += $this->a;
-        $e += $this->a;
-        parent::Arc($xc,$yc,$w,$h,$s,$e);
+	list($xc,$yc) = $this->Rotate($xc,$yc);
+	$s += $this->a;
+	$e += $this->a;
+	parent::Arc($xc,$yc,$w,$h,$s,$e);
     }
 
     function FilledArc($xc,$yc,$w,$h,$s,$e,$style='') {
-        list($xc,$yc) = $this->Rotate($xc,$yc);
-        $s += $this->a;
-        $e += $this->a;
-        parent::FilledArc($xc,$yc,$w,$h,$s,$e);
+	list($xc,$yc) = $this->Rotate($xc,$yc);
+	$s += $this->a;
+	$e += $this->a;
+	parent::FilledArc($xc,$yc,$w,$h,$s,$e);
     }
 
     function SetMargin($lm,$rm,$tm,$bm) {
-        parent::SetMargin($lm,$rm,$tm,$bm);
-        $this->UpdateRotMatrice();
-    }
-
+	parent::SetMargin($lm,$rm,$tm,$bm);
+	$this->dx=$this->left_margin+$this->plotwidth/2;
+	$this->dy=$this->top_margin+$this->plotheight/2;
+	$this->UpdateRotMatrice();
+    }
+	
     function Rotate($x,$y) {
-        // Optimization. Ignore rotation if Angle==0 || Angle==360
-        if( $this->a == 0 || $this->a == 360 ) {
-            return array($x + $this->transx, $y + $this->transy );
-        }
-        else {
-            $x1=round($this->m[0][0]*$x + $this->m[0][1]*$y,1) + $this->m[0][2] + $this->transx;
-            $y1=round($this->m[1][0]*$x + $this->m[1][1]*$y,1) + $this->m[1][2] + $this->transy;
-            return array($x1,$y1);
-        }
-    }
-
+	// Optimization. Ignore rotation if Angle==0 || Angle==360
+	if( $this->a == 0 || $this->a == 360 ) {
+	    return array($x + $this->transx, $y + $this->transy );
+	}
+	else {
+	    $x1=round($this->m[0][0]*$x + $this->m[0][1]*$y,1) + $this->m[0][2] + $this->transx;
+	    $y1=round($this->m[1][0]*$x + $this->m[1][1]*$y,1) + $this->m[1][2] + $this->transy;
+	    return array($x1,$y1);
+	}
+    }
+	
     function CopyMerge($fromImg,$toX,$toY,$fromX,$fromY,$toWidth,$toHeight,$fromWidth=-1,$fromHeight=-1,$aMix=100) {
-        list($toX,$toY) = $this->Rotate($toX,$toY);
-        parent::CopyMerge($fromImg,$toX,$toY,$fromX,$fromY,$toWidth,$toHeight,$fromWidth,$fromHeight,$aMix);
+	list($toX,$toY) = $this->Rotate($toX,$toY);
+	parent::CopyMerge($fromImg,$toX,$toY,$fromX,$fromY,$toWidth,$toHeight,$fromWidth,$fromHeight,$aMix);
 
     }
 
     function ArrRotate($pnts) {
-        $n = count($pnts)-1;
-        for($i=0; $i < $n; $i+=2) {
-            list ($x,$y) = $this->Rotate($pnts[$i],$pnts[$i+1]);
-            $pnts[$i] = $x; $pnts[$i+1] = $y;
-        }
-        return $pnts;
+	$n = count($pnts)-1;
+	for($i=0; $i < $n; $i+=2) {
+	    list ($x,$y) = $this->Rotate($pnts[$i],$pnts[$i+1]);
+	    $pnts[$i] = $x; $pnts[$i+1] = $y;
+	}
+	return $pnts;
     }
 
     function DashedLine($x1,$y1,$x2,$y2,$dash_length=1,$dash_space=4) {
-        list($x1,$y1) = $this->Rotate($x1,$y1);
-        list($x2,$y2) = $this->Rotate($x2,$y2);
-        parent::DashedLine($x1,$y1,$x2,$y2,$dash_length,$dash_space);
-    }
-
+	list($x1,$y1) = $this->Rotate($x1,$y1);
+	list($x2,$y2) = $this->Rotate($x2,$y2);
+	parent::DashedLine($x1,$y1,$x2,$y2,$dash_length,$dash_space);
+    }
+	
     function Line($x1,$y1,$x2,$y2) {
-        list($x1,$y1) = $this->Rotate($x1,$y1);
-        list($x2,$y2) = $this->Rotate($x2,$y2);
-        parent::Line($x1,$y1,$x2,$y2);
+	list($x1,$y1) = $this->Rotate($x1,$y1);
+	list($x2,$y2) = $this->Rotate($x2,$y2);
+	parent::Line($x1,$y1,$x2,$y2);
     }
 
     function Rectangle($x1,$y1,$x2,$y2) {
-        // Rectangle uses Line() so it will be rotated through that call
-        parent::Rectangle($x1,$y1,$x2,$y2);
-    }
-
+	// Rectangle uses Line() so it will be rotated through that call
+	parent::Rectangle($x1,$y1,$x2,$y2);
+    }
+	
     function FilledRectangle($x1,$y1,$x2,$y2) {
-        if( $y1==$y2 || $x1==$x2 )
-        $this->Line($x1,$y1,$x2,$y2);
-        else
-        $this->FilledPolygon(array($x1,$y1,$x2,$y1,$x2,$y2,$x1,$y2));
-    }
-
+	if( $y1==$y2 || $x1==$x2 )
+	    $this->Line($x1,$y1,$x2,$y2);
+	else 
+	    $this->FilledPolygon(array($x1,$y1,$x2,$y1,$x2,$y2,$x1,$y2));
+    }
+	
     function Polygon($pnts,$closed=FALSE,$fast=FALSE) {
-        // Polygon uses Line() so it will be rotated through that call unless
-        // fast drawing routines are used in which case a rotate is needed
-        if( $fast ) {
-            parent::Polygon($this->ArrRotate($pnts));
-        }
-        else {
-            parent::Polygon($pnts,$closed,$fast);
-        }
-    }
-
+	// Polygon uses Line() so it will be rotated through that call unless
+	// fast drawing routines are used in which case a rotate is needed
+	if( $fast ) {
+	    parent::Polygon($this->ArrRotate($pnts));
+	}
+	else
+	    parent::Polygon($pnts,$closed,$fast);
+    }
+	
     function FilledPolygon($pnts) {
-        parent::FilledPolygon($this->ArrRotate($pnts));
-    }
-
+	parent::FilledPolygon($this->ArrRotate($pnts));
+    }
+	
     function Point($x,$y) {
-        list($xp,$yp) = $this->Rotate($x,$y);
-        parent::Point($xp,$yp);
-    }
-
+	list($xp,$yp) = $this->Rotate($x,$y);
+	parent::Point($xp,$yp);
+    }
+	
     function StrokeText($x,$y,$txt,$dir=0,$paragraph_align="left",$debug=false) {
-        list($xp,$yp) = $this->Rotate($x,$y);
-        return parent::StrokeText($xp,$yp,$txt,$dir,$paragraph_align,$debug);
+	list($xp,$yp) = $this->Rotate($x,$y);
+	return parent::StrokeText($xp,$yp,$txt,$dir,$paragraph_align,$debug);
     }
 }
 
-//=======================================================================
+//===================================================
 // CLASS ImgStreamCache
-// Description: Handle caching of graphs to files. All image output goes
-//              through this class
-//=======================================================================
+// Description: Handle caching of graphs to files
+//===================================================
 class ImgStreamCache {
-    private $cache_dir, $timeout=0;  // Infinite timeout
+    private $cache_dir, $img=null, $timeout=0; 	// Infinite timeout
     //---------------
     // CONSTRUCTOR
-    function __construct($aCacheDir=CACHE_DIR) {
-        $this->cache_dir = $aCacheDir;
-    }
-
-    //---------------
-    // PUBLIC METHODS
+    function ImgStreamCache($aImg, $aCacheDir=CACHE_DIR) {
+	$this->img = $aImg;
+	$this->cache_dir = $aCacheDir;
+    }
+
+//---------------
+// PUBLIC METHODS	
 
     // Specify a timeout (in minutes) for the file. If the file is older then the
@@ -2122,191 +1478,142 @@
     // timeout is set to -1 this is the same as infinite small timeout
     function SetTimeout($aTimeout) {
-        $this->timeout=$aTimeout;
-    }
-
+	$this->timeout=$aTimeout;	
+    }
+	
     // Output image to browser and also write it to the cache
     function PutAndStream($aImage,$aCacheFileName,$aInline,$aStrokeFileName) {
-
-        // Check if we should always stroke the image to a file
-        if( _FORCE_IMGTOFILE ) {
-            $aStrokeFileName = _FORCE_IMGDIR.GenImgName();
-        }
-
-        if( $aStrokeFileName != '' ) {
-
-            if( $aStrokeFileName == 'auto' ) {
-                $aStrokeFileName = GenImgName();
-            }
-
-            if( file_exists($aStrokeFileName) ) {
-
-                // Wait for lock (to make sure no readers are trying to access the image)
-                $fd = fopen($aStrokeFileName,'w');
-                $lock = flock($fd, LOCK_EX);
-
-                // Since the image write routines only accepts a filename which must not
-                // exist we need to delete the old file first
-                if( !@unlink($aStrokeFileName) ) {
-                    $lock = flock($fd, LOCK_UN);
-                    JpGraphError::RaiseL(25111,$aStrokeFileName);
-                    //(" Can't delete cached image $aStrokeFileName. Permission problem?");
-                }
-                $aImage->Stream($aStrokeFileName);
-                $lock = flock($fd, LOCK_UN);
-                fclose($fd);
-
-            }
-            else {
-                $aImage->Stream($aStrokeFileName);
-            }
-
-            return;
-        }
-
-        if( $aCacheFileName != '' && USE_CACHE) {
-
-            $aCacheFileName = $this->cache_dir . $aCacheFileName;
-            if( file_exists($aCacheFileName) ) {
-                if( !$aInline ) {
-                    // If we are generating image off-line (just writing to the cache)
-                    // and the file exists and is still valid (no timeout)
-                    // then do nothing, just return.
-                    $diff=time()-filemtime($aCacheFileName);
-                    if( $diff < 0 ) {
-                        JpGraphError::RaiseL(25112,$aCacheFileName);
-                        //(" Cached imagefile ($aCacheFileName) has file date in the future!!");
-                    }
-                    if( $this->timeout>0 && ($diff <= $this->timeout*60) ) return;
-                }
-
-                // Wait for lock (to make sure no readers are trying to access the image)
-                $fd = fopen($aCacheFileName,'w');
-                $lock = flock($fd, LOCK_EX);
-
-                if( !@unlink($aCacheFileName) ) {
-                    $lock = flock($fd, LOCK_UN);
-                    JpGraphError::RaiseL(25113,$aStrokeFileName);
-                    //(" Can't delete cached image $aStrokeFileName. Permission problem?");
-                }
-                $aImage->Stream($aCacheFileName);
-                $lock = flock($fd, LOCK_UN);
-                fclose($fd);
-
-            }
-            else {
-                $this->MakeDirs(dirname($aCacheFileName));
-                if( !is_writeable(dirname($aCacheFileName)) ) {
-                    JpGraphError::RaiseL(25114,$aCacheFileName);
-                    //('PHP has not enough permissions to write to the cache file '.$aCacheFileName.'. Please make sure that the user running PHP has write permission for this file if you wan to use the cache system with JpGraph.');
-                }
-                $aImage->Stream($aCacheFileName);
-            }
-
-            $res=true;
-            // Set group to specified
-            if( CACHE_FILE_GROUP != '' ) {
-                $res = @chgrp($aCacheFileName,CACHE_FILE_GROUP);
-            }
-            if( CACHE_FILE_MOD != '' ) {
-                $res = @chmod($aCacheFileName,CACHE_FILE_MOD);
-            }
-            if( !$res ) {
-                JpGraphError::RaiseL(25115,$aStrokeFileName);
-                //(" Can't set permission for cached image $aStrokeFileName. Permission problem?");
-            }
-
-            $aImage->Destroy();
-            if( $aInline ) {
-                if ($fh = @fopen($aCacheFileName, "rb") ) {
-                    $aImage->Headers();
-                    fpassthru($fh);
-                    return;
-                }
-                else {
-                    JpGraphError::RaiseL(25116,$aFile);//(" Cant open file from cache [$aFile]");
-                }
-            }
-        }
-        elseif( $aInline ) {
-            $aImage->Headers();
-            $aImage->Stream();
-            return;
-        }
-    }
-
-    function IsValid($aCacheFileName) {
-        $aCacheFileName = $this->cache_dir.$aCacheFileName;
-        if ( USE_CACHE && file_exists($aCacheFileName) ) {
-            $diff=time()-filemtime($aCacheFileName);
-            if( $this->timeout>0 && ($diff > $this->timeout*60) ) {
-                return false;
-            }
-            else {
-                return true;
-            }
-        }
-        else {
-            return false;
-        }
-    }
-
-    function StreamImgFile($aImage,$aCacheFileName) {
-        $aCacheFileName = $this->cache_dir.$aCacheFileName;
-        if ( $fh = @fopen($aCacheFileName, 'rb') ) {
-            $lock = flock($fh, LOCK_SH);
-            $aImage->Headers();
-            fpassthru($fh);
-            $lock = flock($fh, LOCK_UN);
-            fclose($fh);
-            return true;
-        }
-        else {
-            JpGraphError::RaiseL(25117,$aCacheFileName);//(" Can't open cached image \"$aCacheFileName\" for reading.");
-        }
-    }
-
+	// Some debugging code to brand the image with numbe of colors
+	// used
+	GLOBAL $gJpgBrandTiming;
+
+	if( $gJpgBrandTiming ) {
+	    global $tim;
+	    $t=$tim->Pop()/1000.0;
+	    $c=$aImage->SetColor("black");
+	    $t=sprintf(BRAND_TIME_FORMAT,round($t,3));
+	    imagestring($this->img->img,2,5,$this->img->height-20,$t,$c);			
+	}
+
+	// Check if we should stroke the image to an arbitrary file
+	if( _FORCE_IMGTOFILE ) {
+	    $aStrokeFileName = _FORCE_IMGDIR.GenImgName();
+	}
+
+	if( $aStrokeFileName!="" ) {
+	    if( $aStrokeFileName == "auto" )
+		$aStrokeFileName = GenImgName();
+	    if( file_exists($aStrokeFileName) ) {
+		// Delete the old file
+		if( !@unlink($aStrokeFileName) )
+		    JpGraphError::RaiseL(25111,$aStrokeFileName);//(" Can't delete cached image $aStrokeFileName. Permission problem?");
+	    }
+	    $aImage->Stream($aStrokeFileName);
+	    return;
+	}
+
+	if( $aCacheFileName != "" && USE_CACHE) {
+
+	    $aCacheFileName = $this->cache_dir . $aCacheFileName;
+	    if( file_exists($aCacheFileName) ) {
+		if( !$aInline ) {
+		    // If we are generating image off-line (just writing to the cache)
+		    // and the file exists and is still valid (no timeout)
+		    // then do nothing, just return.
+		    $diff=time()-filemtime($aCacheFileName);
+		    if( $diff < 0 )
+			JpGraphError::RaiseL(25112,$aCacheFileName);//(" Cached imagefile ($aCacheFileName) has file date in the future!!");
+		    if( $this->timeout>0 && ($diff <= $this->timeout*60) ) 
+			return;		
+		}			
+		if( !@unlink($aCacheFileName) )
+		    JpGraphError::RaiseL(25113,$aStrokeFileName);//(" Can't delete cached image $aStrokeFileName. Permission problem?");
+		$aImage->Stream($aCacheFileName);	
+	    }
+	    else {
+		$this->MakeDirs(dirname($aCacheFileName));
+		if( !is_writeable(dirname($aCacheFileName)) ) {
+		    JpGraphError::RaiseL(25114,$aCacheFileName);//('PHP has not enough permissions to write to the cache file '.$aCacheFileName.'. Please make sure that the user running PHP has write permission for this file if you wan to use the cache system with JpGraph.');
+		}
+		$aImage->Stream($aCacheFileName);
+	    }
+			
+	    $res=true;
+	    // Set group to specified
+	    if( CACHE_FILE_GROUP != "" )
+		$res = @chgrp($aCacheFileName,CACHE_FILE_GROUP);
+	    if( CACHE_FILE_MOD != "" )
+		$res = @chmod($aCacheFileName,CACHE_FILE_MOD);
+	    if( !$res )
+		JpGraphError::RaiseL(25115,$aStrokeFileName);//(" Can't set permission for cached image $aStrokeFileName. Permission problem?");
+			
+	    $aImage->Destroy();
+	    if( $aInline ) {
+		if ($fh = @fopen($aCacheFileName, "rb") ) {
+		    $this->img->Headers();
+		    fpassthru($fh);
+		    return;
+		}
+		else
+		    JpGraphError::RaiseL(25116,$aFile);//(" Cant open file from cache [$aFile]"); 
+	    }
+	}
+	elseif( $aInline ) {
+	    $this->img->Headers();	 		
+	    $aImage->Stream();	
+	    return;
+	}
+    }
+	
     // Check if a given image is in cache and in that case
     // pass it directly on to web browser. Return false if the
     // image file doesn't exist or exists but is to old
-    function GetAndStream($aImage,$aCacheFileName) {
-        if( $this->Isvalid($aCacheFileName) ) {
-            $this->StreamImgFile($aImage,$aCacheFileName);
-        }
-        else {
-            return false;
-        }
-    }
-
+    function GetAndStream($aCacheFileName) {
+	$aCacheFileName = $this->cache_dir.$aCacheFileName;		 
+	if ( USE_CACHE && file_exists($aCacheFileName) && $this->timeout>=0 ) {
+	    $diff=time()-filemtime($aCacheFileName);
+	    if( $this->timeout>0 && ($diff > $this->timeout*60) ) {
+		return false;		
+	    }
+	    else {
+		if ($fh = @fopen($aCacheFileName, "rb")) {
+		    $this->img->Headers();
+		    fpassthru($fh);
+		    return true;
+		}
+		else
+		    JpGraphError::RaiseL(25117,$aCacheFileName);//(" Can't open cached image \"$aCacheFileName\" for reading.");
+	    }
+	} 
+	return false;
+    }
+	
     //---------------
-    // PRIVATE METHODS
+    // PRIVATE METHODS	
     // Create all necessary directories in a path
     function MakeDirs($aFile) {
-        $dirs = array();
-        // In order to better work when open_basedir is enabled
-        // we do not create directories in the root path
-        while ( $aFile != '/' && !(file_exists($aFile)) ) {
-            $dirs[] = $aFile.'/';
-            $aFile = dirname($aFile);
-        }
-        for ($i = sizeof($dirs)-1; $i>=0; $i--) {
-            if(! @mkdir($dirs[$i],0777) ) {
-                JpGraphError::RaiseL(25118,$aFile);//(" Can't create directory $aFile. Make sure PHP has write permission to this directory.");
-            }
-            // We also specify mode here after we have changed group.
-            // This is necessary if Apache user doesn't belong the
-            // default group and hence can't specify group permission
-            // in the previous mkdir() call
-            if( CACHE_FILE_GROUP != "" ) {
-                $res=true;
-                $res =@chgrp($dirs[$i],CACHE_FILE_GROUP);
-                $res = @chmod($dirs[$i],0777);
-                if( !$res ) {
-                    JpGraphError::RaiseL(25119,$aFile);//(" Can't set permissions for $aFile. Permission problems?");
-                }
-            }
-        }
-        return true;
-    }
+	$dirs = array();
+	while ( !(file_exists($aFile)) ) {
+	    $dirs[] = $aFile;
+	    $aFile = dirname($aFile);
+	}
+	for ($i = sizeof($dirs)-1; $i>=0; $i--) {
+	    if(! @mkdir($dirs[$i],0777) )
+		JpGraphError::RaiseL(25118,$aFile);//(" Can't create directory $aFile. Make sure PHP has write permission to this directory.");
+	    // We also specify mode here after we have changed group. 
+	    // This is necessary if Apache user doesn't belong the
+	    // default group and hence can't specify group permission
+	    // in the previous mkdir() call
+	    if( CACHE_FILE_GROUP != "" ) {
+		$res=true;
+		$res =@chgrp($dirs[$i],CACHE_FILE_GROUP);
+		$res = @chmod($dirs[$i],0777);
+		if( !$res )
+		    JpGraphError::RaiseL(25119,$aFile);//(" Can't set permissions for $aFile. Permission problems?");
+	    }
+	}
+	return true;
+    }	
 } // CLASS Cache
 
+
 ?>
